#!/usr/bin/env python
# -*- coding: UTF-8 -*-
##
##    Copyright (C) 2005 manatlan manatlan[at]gmail(dot)com
##    Copyright (C) 2006 d2       david(point)decotigny[at]free(dot)fr
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## frontend for http://linuxfr.org/~11010010/20437.html
##
"""
manatlan:
- spin sur la durée
- meilleur gestion des process
- enregistrement anterieur zappé
- qques modifs dans l'interface

david.decotigny at free point fr (15/04/2006):
- 1 seul script d'enregistrement, supporte les 2 qualites low/high
- affiche la taille du fichier sauvegarde
- supporte les noms de repertoires avec des espaces (au plus 1 a suivre)
- double-clic pour envoyer le stream/fichier dans freecorder_play.sh
"""
# Python module freecorder.py
# Autogenerated from freecorder.glade
# Generated on Sun Jan  1 20:44:06 2006

# Warning: Do not modify any context comment such as #--
# They are required to keep user's code

import os,sys,signal,datetime

import gobject,gtk

from SimpleGladeApp import SimpleGladeApp
from SimpleGladeApp import bindtextdomain

import urllib2

app_name = "freecorder"
app_version = "0.3.3"

glade_dir = ""
locale_dir = ""

bindtextdomain(app_name, locale_dir)

import time,string
import re

def shellquote(arg):
    return "'" + arg.replace("'", "'\\''") + "'"

def cmdstring(cmds):
    return string.join([ shellquote(c) for c in cmds ])

def run(cmds):
    p = os.popen(cmdstring(cmds), 'r')
    if p == None:
        return None
    out = string.join(p.readlines() ).strip()
    p.close()
    return out

def getAtProperties(code):
    b=run(["at","-c",str(code)])
    retval=[]
    if "./freecorder_job.sh" in b:
        a=re.compile(r"direct +'.+' +'(.+)' +'(.+)' +'(.*)'$")
        g=a.search(b)
        if g:
            quality=g.group(1)
            url=g.group(2)
            outfile=g.group(3)
            pidfile=outfile + ".pid"
            a=re.compile(r"\[([^\]]+)\]\[([^\]]+)\]\[([^\]]+)\]\.mpg")
            g=a.search(outfile)
            if g:
                chaine=g.group(1)
                debut=g.group(2)
                fin=g.group(3)
                retval=[chaine,quality,debut,fin,url,outfile,pidfile]
    return retval

def getAtList():
    l=[]
    buf=run(["atq"])
    if buf:
        for i in buf.split("\n"):
            t=i.strip().split("\t")
            code,date = t[0],t[1][:16]
            descr = getAtProperties(code)
            if descr:
                l.append( [code] + descr )
    return l

def delAt(code):
    run(["atrm",str(code)])

def genOutfileName(chaine,daff,fin):
    return "[%s][%s][%s].mpg" % (chaine,daff,fin)

def goRecord(highQuality,debut,fin,stream,chaine,destination):
    qual = highQuality and "vlc_high" or "vlc_low"

    file = os.path.join(destination,genOutfileName(chaine,debut,fin))

    cmds = ["./freecorder_job.sh",debut,fin,qual,stream,file]
#    print cmds
    os.spawnvp(os.P_NOWAIT, cmds[0], cmds)

def MessageBox(parent,data,title="freecorder message"):
    dialog = gtk.Dialog(title, parent, 0,
            (gtk.STOCK_OK, gtk.RESPONSE_OK)
            )
    dialog.set_default_response(gtk.RESPONSE_OK)

    hbox = gtk.HBox(False, 8)
    hbox.set_border_width(8)
    dialog.vbox.pack_start(hbox, False, False, 0)

    stock = gtk.image_new_from_stock(
            gtk.STOCK_DIALOG_INFO,
            gtk.ICON_SIZE_DIALOG)
    hbox.pack_start(stock, False, False, 0)

    table = gtk.Table(2, 2)
    table.set_row_spacings(4)
    table.set_col_spacings(4)
    hbox.pack_start(table, True, True, 0)

    label = gtk.Label(data)
    label.set_selectable(True)
    table.attach(label, 0, 2, 0, 1)

    dialog.show_all()

    response = dialog.run()

    dialog.destroy()

def normalize(valRech):
    valRech=unicode(valRech).encode("utf_16")
    sfrom = ur"àâäéèêëïîôöûùüç /\<>'|[]!?-+:;"
    sto   = ur"aaaeeeeiioouuuc_______________"
    return valRech.translate( string.maketrans(sfrom.encode("utf_16"),sto.encode("utf_16")) ).decode("utf_16")


def m3u2list():
    list = []
    chaine = None
    for i in urllib2.urlopen("http://mafreebox.freebox.fr/freeboxtv/playlist.m3u"):
        ligne = i.strip()
        if ligne:
            if chaine:
                list.append( (normalize(chaine),ligne) )
                chaine=None
            if ligne[:7]=="#EXTINF":
                chaine = ligne.split(" - ")[-1]

    return list

def getHeure(s):
    if ":" in s:
        t=s.strip().split(":")
        try:
            h=int(t[0])
            m=int(t[1])
        except:
            return
        return datetime.time(h,m)

def callback_refresh_prog_list(window):
    window.refresh_prog_list()
    return True

class dialogDate(SimpleGladeApp):
    def __init__(self, curDate=None, path="freecorder.glade",
                 root="dialog_date",
                 domain=app_name, **kwargs):
        self.startDate = curDate
        self.retdate = None
        path = os.path.join(glade_dir, path)
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)

    def new(self):
        if self.startDate:
            self.calendar1.select_month(self.startDate.month-1,
                                        self.startDate.year)
            self.calendar1.select_day(self.startDate.day)

    def on_ok_pressed(self, widget, *args):
        d = self.calendar1.get_date()
        d = datetime.date(d[0], d[1]+1, d[2])
        if d < datetime.date.today():
            MessageBox(self.main_widget, "La date est dans le passé !")
        else:
            self.retdate = d
            self.dialog_date.destroy()
            self.quit()

    def on_cancel_pressed(self, widget, *args):
        self.dialog_date.destroy()
        self.quit()

    def run(self):
        SimpleGladeApp.run(self)
        return self.retdate


class Window1(SimpleGladeApp):

    def __init__(self, data_dir=None,
                 path="freecorder.glade",
                 root="window1",
                 domain=app_name, **kwargs):
        self.dataDir = data_dir
        self.recordDate = datetime.date.today()
        gobject.timeout_add(500, callback_refresh_prog_list, self)
        path = os.path.join(glade_dir, path)
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)

    #-- Window1.new {
    def new(self):
        if self.dataDir:
            self.e_dest.set_text( self.dataDir )

        cell_renderer = gtk.CellRendererText()
        column = gtk.TreeViewColumn("Chaine", cell_renderer,text=0)
        self.playlist.append_column(column)

        l = m3u2list()
        m=gtk.ListStore( str,str,)
        m.clear()
        for chaine,url in l:
            m.append( [chaine,url,] )
        self.playlist.set_model(m)

        #~ column = gtk.TreeViewColumn("code", gtk.CellRendererText(),text=0)
        #~ self.tv_list.append_column(column)
        column = gtk.TreeViewColumn("chaine", gtk.CellRendererText(),text=1)
        self.tv_list.append_column(column)
        column = gtk.TreeViewColumn("début", gtk.CellRendererText(),text=3)
        self.tv_list.append_column(column)
        column = gtk.TreeViewColumn("fin", gtk.CellRendererText(),text=4)
        self.tv_list.append_column(column)
        column = gtk.TreeViewColumn("qualité", gtk.CellRendererText(),text=2)
        self.tv_list.append_column(column)
        column = gtk.TreeViewColumn("état", gtk.CellRendererText(),text=7)
        self.tv_list.append_column(column)
        column = gtk.TreeViewColumn("Taille", gtk.CellRendererText(),text=8)
        self.tv_list.append_column(column)

        m=gtk.ListStore( str,str,str,str,str,str,str,str,str )
        self.fillAt(m)
        self.tv_list.set_model(m)

        d = datetime.datetime.now()
        self.e_debut.set_text( d.strftime("%H:%M") )
        self.date_button.set_label(self.recordDate.strftime("%x"))

        self.main_widget.resize( 500,150 )

    #-- Window1.new }

    #-- Window1 custom methods {
    def fillAt(self,m, iter=None):
        if iter != None:
            selcode = m.get_value(iter, 0)
        else:
            selcode = -1
        m.clear()
        retiter = None
        for code,chaine,qual,d,f,url,outfile,pidfile in getAtList():
            status="waiting..."
            fsize=""
            if os.path.exists(pidfile):
                status="recording"
                try:
                    sz=os.path.getsize(outfile) * 1.0
                    if sz < 1024: fsize="%d B" % sz
                    elif sz < (1 << 20): fsize="%.1f kB" % (sz / (1 << 10))
                    elif sz < (1 << 30): fsize="%.1f MB" % (sz / (1 << 20))
                    else: fsize="%.1f GB" % (sz / (1 << 30))
                except:
                    pass
            i = m.append( [code,chaine,qual,d,f,outfile,pidfile,status,fsize] )
            if code == selcode:
                retiter = i
        return retiter

    #-- Window1 custom methods }

    #-- Window1.on_window1_delete_event {
    def on_window1_delete_event(self, widget, *args):
        gtk.main_quit()
    #-- Window1.on_window1_delete_event }

    #-- Window1.on_playlist_cursor_changed {
    def on_playlist_cursor_changed(self, widget, *args):
        pass
    #-- Window1.on_playlist_cursor_changed }

    #-- Window1.on_date_button_pressed {
    def on_date_button_pressed(self, widget, *args):
        d = dialogDate(self.recordDate)
        d = d.run()
        if d:
            self.recordDate = d
            self.on_sb_time_changed(self.sb_time)
        self.date_button.set_label(self.recordDate.strftime("%x"))
    #-- Window1.on_date_button_pressed }

    #-- Window1.on_playlist_button_press_event {
    def on_playlist_button_press_event(self, widget, *args):
        if (args[0].type != gtk.gdk._2BUTTON_PRESS):
            return
        treeselection = widget.get_selection()
        model, iter0 = treeselection.get_selected()
        stream = model.get_value(iter0, 1)
        cmds = ["./freecorder_play.sh",stream]
        os.spawnvp(os.P_NOWAIT, cmds[0], cmds)
    #-- Window1.on_playlist_button_press_event }


    #-- Window1.on_btn_dest_clicked {
    def on_btn_dest_clicked(self, widget, *args):
        dialog = gtk.FileChooserDialog ("Choisir le répertoire de Destination",
             None, gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
             (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OPEN,
              gtk.RESPONSE_OK))
        dialog.set_default_response (gtk.RESPONSE_OK)
        #~ dialog.set_transient_for (self.dlg_add)

        # preselect the previous mount point
        dialog.select_filename (self.e_dest.get_text())

        response = dialog.run ()
        if response == gtk.RESPONSE_OK:
              self.e_dest.set_text( dialog.get_filename() )

        dialog.destroy()
    #-- Window1.on_btn_dest_clicked }

    def refresh_prog_list(self):
        treeselection = self.tv_list.get_selection()
        m, i = treeselection.get_selected()
        i = self.fillAt(m, i)
        if i != None:
            treeselection.select_iter(i)

    #-- Window1.on_btn_valid_clicked {
    def on_btn_valid_clicked(self, widget, *args):
        treeselection = self.playlist.get_selection()
        model, iter0 = treeselection.get_selected()
        if not iter0:
            MessageBox(self.main_widget,"Vous devez selectionner une chaine")
        else:
            chaine = model.get_value(iter0,0)
            stream = model.get_value(iter0,1)

            quality= self.rb_haute.get_active()

            destination = self.e_dest.get_text()
            if not os.path.isdir(destination):
                MessageBox(self.main_widget,"Le répertoire de destination n'existe pas")
            else:
                debut = getHeure(self.e_debut.get_text())
                if not debut:
                    MessageBox(self.main_widget,"L'heure de début n'est pas bonne (ex: '14:35')")
                else:
                    fin = debut = datetime.datetime.combine(self.recordDate, debut)
                    fin += datetime.timedelta(minutes=int(self.sb_time.get_text()))
                    debut = debut.strftime("%F %H:%M")
                    fin = fin.strftime("%F %H:%M")
                    goRecord(quality,debut,fin,stream,chaine,destination)
                    time.sleep(.1)
                    self.refresh_prog_list()

    #-- Window1.on_btn_valid_clicked }

    #-- Window1.on_tv_list_button_release_event {
    def on_tv_list_button_release_event(self, widget, *args):
        #~ if args[0].button == 3:
        pass
    #-- Window1.on_tv_list_button_release_event }

    #-- Window1.on_tv_list_button_press_event {
    def on_tv_list_button_press_event(self, widget, *args):
        if (args[0].type != gtk.gdk._2BUTTON_PRESS):
            return
        treeselection = widget.get_selection()
        model, iter0 = treeselection.get_selected()
        fname = model.get_value(iter0, 5)
        try:
            if os.path.getsize(fname) > 0:
                cmds = ["./freecorder_play.sh",fname]
                os.spawnvp(os.P_NOWAIT, cmds[0], cmds)
        except:
            pass
    #-- Window1.on_tv_list_button_press_event }

    #-- Window1.on_btn_supprimer_clicked {
    def on_btn_supprimer_clicked(self, widget, *args):
        treeselection = self.tv_list.get_selection()
        model, iter0 = treeselection.get_selected()
        if not iter0:
            MessageBox(self.main_widget,"Vous devez selectionner un enregistrement")
        else:
            code= model.get_value(iter0,0)
            print "Cancel job",code
            props = getAtProperties(code)
            delAt(code)

            file=""
            if props:
                file=props[6]
            if os.path.isfile(file):
                # le fichier "pid" existe (c donc que vlc tourne)
                for pid in open(file):
                    # on tue tous les pid du fichier
                    os.kill(int(pid),signal.SIGKILL)
                print "kill vlc for",file
                os.unlink(file)

            self.fillAt(model)
    #-- Window1.on_btn_supprimer_clicked }

    #-- Window1.on_btn_quitter_clicked {
    def on_btn_quitter_clicked(self, widget, *args):
        gtk.main_quit()
    #-- Window1.on_btn_quitter_clicked }

    #-- Window1.on_sb_time_changed {
    def on_sb_time_changed(self, widget, *args):
        newval = widget.get_text()
        if newval:
            debut = getHeure(self.e_debut.get_text())
            if debut:
                fin = debut = datetime.datetime.combine(self.recordDate, debut)
                fin += datetime.timedelta(minutes=int(newval))
                self.e_fin.set_text( fin.strftime("%c") )
    #-- Window1.on_sb_time_changed }

    #-- Window1.on_from_changed {
    def on_from_changed(self, widget, *args):
        self.on_sb_time_changed(self.sb_time)
    #-- Window1.on_from_changed }


#-- main {
def main(data_dir = None):
    window1 = Window1(data_dir)
    window1.run()


if __name__ == "__main__":
    startDir=os.getcwd()
    try:
        os.chdir(os.path.dirname(sys.argv[0]))
    except:
        pass
    main(startDir)

#-- main }
